import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ExpressTemplateDetail, ExpressTemplateDetailParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询运费模板
 */
export async function pageExpressTemplateDetail(params: ExpressTemplateDetailParam) {
  const res = await request.get<ApiResult<PageResult<ExpressTemplateDetail>>>(
    MODULES_API_URL + '/shop/express-template-detail/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询运费模板列表
 */
export async function listExpressTemplateDetail(params?: ExpressTemplateDetailParam) {
  const res = await request.get<ApiResult<ExpressTemplateDetail[]>>(
    MODULES_API_URL + '/shop/express-template-detail',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加运费模板
 */
export async function addExpressTemplateDetail(data: ExpressTemplateDetail) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template-detail',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改运费模板
 */
export async function updateExpressTemplateDetail(data: ExpressTemplateDetail) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template-detail',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除运费模板
 */
export async function removeExpressTemplateDetail(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template-detail/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除运费模板
 */
export async function removeBatchExpressTemplateDetail(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template-detail/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询运费模板
 */
export async function getExpressTemplateDetail(id: number) {
  const res = await request.get<ApiResult<ExpressTemplateDetail>>(
    MODULES_API_URL + '/shop/express-template-detail/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
